import PropTypes from 'prop-types';
export const propTypes = {
  id: PropTypes.string,
  title: PropTypes.string,
  name: PropTypes.string,
  value: PropTypes.bool,
  checked: PropTypes.bool,
  disabled: PropTypes.bool,
  isReadOnly: PropTypes.bool,
  size: PropTypes.oneOf(['small', 'medium', 'large']),
  text: PropTypes.string,
  disableTitle: PropTypes.string,
  dataId: PropTypes.string,
  onChange: PropTypes.func,
  dataSelectorId: PropTypes.string,
  customClass: PropTypes.shape({
    customSwitchWrap: PropTypes.string,
    customSwitch: PropTypes.string,
    customLabel: PropTypes.string
  }),
  customProps: PropTypes.shape({
    SwitchProps: PropTypes.shape({
      WrapperProps: PropTypes.object,
      TrackProps: PropTypes.object
    }),
    LabelProps: PropTypes.object
  }),
  labelPalette: PropTypes.oneOf[("default", "primary", "secondary", "danger", "mandatory", "disable", "dark")],
  labelSize: PropTypes.oneOf(['xsmall', 'small', 'medium', 'large']),
  labelPlacement: PropTypes.string,
  a11y: PropTypes.object
};