"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Layout = require("../Layout");

var _Label = _interopRequireDefault(require("../Label/Label"));

var _SwitchNewModule = _interopRequireDefault(require("./SwitchNew.module.css"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _LibraryContextInit = _interopRequireDefault(require("../Provider/LibraryContextInit"));

var _excluded = ["role"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SwitchNew = function SwitchNew(props) {
  var id = props.id,
      title = props.title,
      name = props.name,
      value = props.value,
      checked = props.checked,
      disabled = props.disabled,
      isReadOnly = props.isReadOnly,
      size = props.size,
      text = props.text,
      disableTitle = props.disableTitle,
      dataId = props.dataId,
      dataSelectorId = props.dataSelectorId,
      onChange = props.onChange,
      customProps = props.customProps,
      customClass = props.customClass,
      labelSize = props.labelSize,
      labelPlacement = props.labelPlacement,
      a11y = props.a11y;

  var handleChange = function handleChange(e) {
    if (!disabled && !isReadOnly && onChange) {
      onChange(!checked, e);
    }
  };

  var _ref = customProps || {},
      _ref$SwitchProps = _ref.SwitchProps,
      SwitchProps = _ref$SwitchProps === void 0 ? {} : _ref$SwitchProps,
      _ref$LabelProps = _ref.LabelProps,
      LabelProps = _ref$LabelProps === void 0 ? {} : _ref$LabelProps;

  var _SwitchProps$WrapperP = SwitchProps.WrapperProps,
      WrapperProps = _SwitchProps$WrapperP === void 0 ? {} : _SwitchProps$WrapperP,
      _SwitchProps$TrackPro = SwitchProps.TrackProps,
      TrackProps = _SwitchProps$TrackPro === void 0 ? {} : _SwitchProps$TrackPro;

  var _ref2 = customClass || {},
      _ref2$customSwitchWra = _ref2.customSwitchWrap,
      customSwitchWrap = _ref2$customSwitchWra === void 0 ? '' : _ref2$customSwitchWra,
      _ref2$customSwitch = _ref2.customSwitch,
      customSwitch = _ref2$customSwitch === void 0 ? '' : _ref2$customSwitch,
      _ref2$customLabel = _ref2.customLabel,
      customLabel = _ref2$customLabel === void 0 ? '' : _ref2$customLabel;

  var _ref3 = a11y || {},
      _ref3$role = _ref3.role,
      role = _ref3$role === void 0 ? 'switch' : _ref3$role,
      a11yAttributes = _objectWithoutProperties(_ref3, _excluded);

  var context = (0, _react.useContext)(_LibraryContextInit["default"]);
  var _context$a11y_onOffLa = context.a11y_onOffLabel,
      a11y_onOffLabel = _context$a11y_onOffLa === void 0 ? true : _context$a11y_onOffLa;
  return /*#__PURE__*/_react["default"].createElement(_Layout.Container, _extends({
    align: "vertical",
    isCover: false,
    isInline: true,
    alignBox: labelPlacement == 'right' ? 'row' : 'row-reverse',
    "data-title": disabled ? disableTitle : title,
    dataSelectorId: dataSelectorId,
    className: customSwitchWrap ? customSwitchWrap : ''
  }, WrapperProps), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(_SwitchNewModule["default"].switchWrapper, " ").concat(_SwitchNewModule["default"]["".concat(size, "_switch")], " ").concat(!disabled && !isReadOnly ? _SwitchNewModule["default"].effect : '', " ").concat(disabled ? _SwitchNewModule["default"].disabled : '')
  }, /*#__PURE__*/_react["default"].createElement("input", _extends({
    type: "checkbox",
    id: id,
    name: name,
    value: value,
    checked: checked,
    disabled: disabled,
    readOnly: isReadOnly,
    onChange: handleChange,
    role: role,
    "aria-checked": checked,
    tabIndex: disabled ? -1 : 0,
    "data-id": dataId,
    "data-test-id": dataId,
    className: "".concat(_SwitchNewModule["default"].track, " ").concat(customSwitch, " ").concat(a11y_onOffLabel ? checked ? _SwitchNewModule["default"].onLabel : _SwitchNewModule["default"].offLabel : '')
  }, a11yAttributes, TrackProps)), /*#__PURE__*/_react["default"].createElement("span", {
    className: _SwitchNewModule["default"].thumb
  }), a11y_onOffLabel ? /*#__PURE__*/_react["default"].createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 ".concat(checked ? '2' : 'var(--switch-off-label-size)', " ").concat(checked ? 'var(--switch-on-label-height)' : 'var(--switch-off-label-size)'),
    className: "".concat(checked ? _SwitchNewModule["default"]["".concat(size, "OnLabelWrapper")] : _SwitchNewModule["default"]["".concat(size, "OffLabelWrapper")], " ").concat(_SwitchNewModule["default"].labelWrapper)
  }, checked ? /*#__PURE__*/_react["default"].createElement("rect", {
    x: "0",
    rx: "0.8",
    ry: "0.8",
    width: "100%",
    height: "100%",
    className: _SwitchNewModule["default"].onLabel
  }) : /*#__PURE__*/_react["default"].createElement("circle", {
    className: _SwitchNewModule["default"].offLabel,
    cx: "50%",
    cy: "50%",
    width: "100%",
    height: "100%",
    fill: "none"
  })) : null), text && /*#__PURE__*/_react["default"].createElement(_Label["default"], _extends({
    customClass: " ".concat(_SwitchNewModule["default"]["switchLabel_".concat(labelPlacement)], "  ").concat(customLabel ? customLabel : ''),
    htmlFor: id,
    size: labelSize,
    type: "subtitle",
    text: text
  }, LabelProps)));
};

var _default = SwitchNew;
exports["default"] = _default;
SwitchNew.defaultProps = _defaultProps.defaultProps;
SwitchNew.propTypes = _propTypes.propTypes;