"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.propTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  id: _propTypes["default"].string,
  title: _propTypes["default"].string,
  name: _propTypes["default"].string,
  value: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  size: _propTypes["default"].oneOf(['small', 'medium', 'large']),
  text: _propTypes["default"].string,
  disableTitle: _propTypes["default"].string,
  dataId: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  dataSelectorId: _propTypes["default"].string,
  customClass: _propTypes["default"].shape({
    customSwitchWrap: _propTypes["default"].string,
    customSwitch: _propTypes["default"].string,
    customLabel: _propTypes["default"].string
  }),
  customProps: _propTypes["default"].shape({
    SwitchProps: _propTypes["default"].shape({
      WrapperProps: _propTypes["default"].object,
      TrackProps: _propTypes["default"].object
    }),
    LabelProps: _propTypes["default"].object
  }),
  labelPalette: _propTypes["default"].oneOf[("default", "primary", "secondary", "danger", "mandatory", "disable", "dark")],
  labelSize: _propTypes["default"].oneOf(['xsmall', 'small', 'medium', 'large']),
  labelPlacement: _propTypes["default"].string,
  a11y: _propTypes["default"].object
};
exports.propTypes = propTypes;